diff --git a/kx.c b/kx.c
index 051a99de..b4dc076c 100644
--- a/kx.c
+++ b/kx.c
@@ -14,6 +14,8 @@ Z K dv_ex(K a,V *p,K b);
 Z K ex0(V *v,K k,I r);
 Z K ex2(V *v,K k);
 Z V ex_(V a,I r);
+I ckDct(K p,K y);
+I ckDct_(K p,K y);
 
 __thread I fer=0;  // Flag Early Return 
 __thread I fwh=0;  // Flag While
@@ -22,6 +24,7 @@ __thread I proj=0; // Projection
 __thread K prnt=0; // Parent of Subfunction 
 __thread I f1s=1;  // Flag 1 for Subfunctions
 __thread I f2s=0;  // Flag 2 for Subfunctions
+I fcl=0; // Flag for kclone
 
 //TODO: for derived verbs like +/ you can add the sub-pieces in parallel
 Z K overDyad(K a, V *p, K b)
@@ -755,8 +758,11 @@ Z K ex2(V*v, K k)  //execute words --- all returns must be Ks. v: word list, k:
     if(1!=sva(v[1])){d=ex1(v+(offsetColon==v[1]?2:3),k,0,0,1); }   // oom -- except it's ok for d to be 0 elsewhere
     d=bk(d)?0:d;
   
+    ckDct(*w,d);
     K h=dot_tetradic_2(w,b,c,d);
-    cd(c); cd(d); M(b,h)
+    cd(c);
+    if(!fcl)cd(d); fcl=0; 
+    M(b,h)
     K j=of(h,b); 
     cd(b);
     R j;
@@ -817,3 +823,17 @@ Z K ex2(V*v, K k)  //execute words --- all returns must be Ks. v: word list, k:
   cd(t2); if(!VA(t3)) cd(t3);
   R e; 
 }
+
+I ckDct(K x,K y)
+{
+  if(!(y && !bk(y) && yt==5 && DT_SIZE<ABS((L)(x)) && xt!=6) && !fcl) R 0;
+  DO(yn, ckDct_(x,kK(y)[yn-i-1]))
+  R 0;
+}
+
+I ckDct_(K x,K y)
+{
+  if(x==y)fcl=1;
+  DO(yn, if(yt==0 || yt==5)ckDct_(x,kK(y)[yn-i-1]))
+  R 0;
+}
\ No newline at end of file
diff --git a/tests.c b/tests.c
index 64f1fa6b..eaa7758c 100644
--- a/tests.c
+++ b/tests.c
@@ -510,8 +510,11 @@ Z I tests02()
   TC(1, x:.+(`a`b;1 2); y:x; ."y.a:11; x.a") //dict references
   TC(x:.+(`a`b;1 2); y:x; y.a:11;x, .+(`a`b;1 2) )  // Bakul comments #205, case 1
   TC(d:.+(`a`b;1 2);d[`a]:d, .+(`a`b;1 2) )         // Bakul comments #205, case 2a
-  //TC(d:.+(`a`b;1 2);d.a:d, .+(`a`b;1 2) )         // Bakul comments #205, case 2b
+  TC(d:.+(`a`b;1 2);d.a:d, .+(`a`b;1 2) )         // Bakul comments #205, case 2b
   TC(d:.+(`a`b;1 2); d[!d]:d, (.((`a;1;);(`b;2;));.((`a;1;);(`b;2;))) )   // #188
+  TC(.((`a;(9 9 9;9 9 9;9 9 9););(`b;2;)), d:.+(`a`b;(3 3#9;2));e:d;d.a[1;2]:e) //case 3
+  TC( (.((`a;(9 9;9 9););(`b;2;));.((`a;(9 9;9 9););(`b;2;))), d:.+(`a`b;(2 2#9;2));d[]:d)  // case 4
+  TC((2;(9 9 9;9 9 9;9 9 9)),  d:.+(`a`b;(3 3#9;2));d[]:|d[])                   //case 5
 
   R 0; 
 }
diff --git a/vd.c b/vd.c
index 273b9adc..a033d182 100644
--- a/vd.c
+++ b/vd.c
@@ -200,12 +200,15 @@ K dot_ref(K *p, K *x, K *z, I s, K c, K y)
 
 K dot_tetradic_2(K *g, K b, K c, K y)
 {
-
-  K x = *g;
-  if(x->c>1 )//fix copy-on-write
+  if(!fcl)
+  { 
+    K x = *g;
+    if(x->c>1) { *g=kclone(x); cd(x); }
+  }
+  else
   {
-    *g=kclone(x);
-    cd(x);
+    K x = y;
+    if(x->c>1) { y=kclone(x); cd(x); }
   }
 
   I bt=b->t, bn=countI(b);
@@ -222,6 +225,7 @@ K dot_tetradic_2(K *g, K b, K c, K y)
   }
   else R TE; //Type Error  7,5,+-3,+-2 TODO: Move inside if possible... ?
   
+  if(fcl)cd(y);
   R *g;
 }
 
diff --git a/vd.h b/vd.h
index 507189e3..92f073a1 100644
--- a/vd.h
+++ b/vd.h
@@ -31,4 +31,4 @@ K demote(K a);
 K lookup(K a,S b);
 K newK(I t,I n);
 K at_verb(K a,K b);
-
+extern I fcl;
